package djmil.cordacheckers.cordaclient.dao;

import java.util.List;
import java.util.Map;
import java.util.UUID;

public record GameState(
    Status status,
    String opponentName,
    Piece.Color opponentColor,
    
    Map<Integer, Piece> board,
    Integer moveNumber,
    List<Integer> previousMove,

    String message,
    UUID uuid
) {
    public static enum Status {
        GAME_PROPOSAL_WAIT_FOR_OPPONENT,
        GAME_PROPOSAL_WAIT_FOR_YOU,
        GAME_PROPOSAL_REJECTED,
        GAME_PROPOSAL_CANCELED,
        GAME_BOARD_WAIT_FOR_OPPONENT,
        GAME_BOARD_WAIT_FOR_YOU,
        GAME_RESULT_YOU_WON,
        GAME_RESULT_YOU_LOOSE;
    }
    
}
