package djmil.cordacheckers.cordaclient;

import static org.assertj.core.api.Assertions.assertThat;

import java.util.List;
import java.util.UUID;

import javax.naming.InvalidNameException;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import com.fasterxml.jackson.core.JsonProcessingException;

import djmil.cordacheckers.cordaclient.dao.GameState;
import djmil.cordacheckers.cordaclient.dao.VirtualNode;
import djmil.cordacheckers.user.HoldingIdentityResolver;

@SpringBootTest
public class GameStateTests {
    @Autowired
    CordaClient cordaClient;

    @Autowired
    HoldingIdentityResolver holdingIdentityResolver;

    @Test
    void testGetVirtualNodeList() throws InvalidNameException {
        List<VirtualNode> vNodes = cordaClient.getVirtualNodeList();

		assertThat(vNodes.size()).isEqualTo(5); // default vNode config for CSDE
    }

    @Test
    void testList() throws JsonProcessingException {
        List<GameState> gsList = cordaClient.gameStateList(
            holdingIdentityResolver.getByUsername("bob"));

        System.out.println(gsList);
    }

    @Test
    void testGet() throws JsonProcessingException {
        GameState gameStateView = cordaClient.gameStateGet(
            holdingIdentityResolver.getByUsername("bob"),
            UUID.fromString("cf357d0a-8f64-4599-b9b5-d263163812d4")
            );

        System.out.println(gameStateView);
    }

}
