package djmil.cordacheckers.contracts;

import static djmil.cordacheckers.contracts.GameCommand.requireThat;
import static djmil.cordacheckers.contracts.UtxoLedgerTransactionUtil.getSingleCommand;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import net.corda.v5.ledger.utxo.transaction.UtxoLedgerTransaction;

public class GameResultContract implements net.corda.v5.ledger.utxo.Contract {

    private final static Logger log = LoggerFactory.getLogger(GameResultContract.class);

    @Override
    public void verify(UtxoLedgerTransaction trx) {
        log.info("GameResultContract.verify() called");

        requireThat(trx.getCommands().size() == 1, GameCommand.REQUIRE_SINGLE_COMMAND);
        final GameCommand command = getSingleCommand(trx, GameCommand.class);

        switch (command.action) {
            case GAME_BOARD_SURRENDER: 
                command.validateGameBoardSurrender(trx);
                break;

            case GAME_RESULT_CREATE:
                command.validateGameResultCreate(trx);
                break;

            default:
                throw new GameCommand.ActionException();
        }
    }

}
